require 'date'

module SEKOIA
  class Formatter
    SekoiaID = "SEKOIA@53288"
    Format = "<%d>1 %s %s %s %s %s %s %s"

    class << self
      def format(
        priority: 14,
        timestamp: nil,
        log: "",
        hostname: "-",
        app_name: "-",
        proc_id: "-",
        msg_id: "-",
        intake_key: ""
      )
        Format % [priority, format_time(timestamp), hostname[0..254], app_name[0..47], proc_id[0..127], msg_id[0..31], format_structured_data(intake_key), log]
      end

      def format_structured_data(intake_key)
        %{[#{SekoiaID} intake_key="#{intake_key}"]}
      end

      def format_time(timestamp)
        return "-" if timestamp.nil?
        return Time.at(timestamp.to_r).utc.to_datetime.rfc3339(6) if timestamp.is_a?(Fluent::EventTime)

        DateTime.strptime(timestamp.to_s, '%s').rfc3339(6)
      end
    end
  end
end
